define('de_epages/sageone/ui/checksynchronizationstatus',[
  'ep/ajax'
], function() {
  return function ( shopId ){
    var initialRefreshIntervalTimeInMilliSeconds = 1000;
    requestShopStatus(initialRefreshIntervalTimeInMilliSeconds, shopId);
  }

  function requestShopStatus(refreshIntervalTimeInMilliSeconds, shopId){
    ep.ajax({
      data : {
        ViewAction : 'JSONSageOneShopStatus',
        ObjectID : shopId
      },
      type : 'get',
      dataType : 'json'
    }).done(function(jsonData) {
      readShopStatus(jsonData, refreshIntervalTimeInMilliSeconds, shopId);
    }).fail( function (){
      location.reload(true);
    } );
  }

  function readShopStatus(jsonData, refreshIntervalTimeInMilliSeconds, shopId) {
    if(jsonData.ShopStatus == "connected" && jsonData.SynchronizationStatus == "busy") {
      var slowDownFactor = 1.2;
      var maximalIntervalTimeInMilliSeconds = 30000;
      if(refreshIntervalTimeInMilliSeconds < maximalIntervalTimeInMilliSeconds) {
        refreshIntervalTimeInMilliSeconds *= slowDownFactor;
      }else{
        refreshIntervalTimeInMilliSeconds = maximalIntervalTimeInMilliSeconds;
      }
      setTimeout(
        function(){
          requestShopStatus(refreshIntervalTimeInMilliSeconds, shopId)
        },
        refreshIntervalTimeInMilliSeconds
      );
    }else{
      location.reload(true);
    }
  }

});